package com.steerinfo.associate.maintenancerecord.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.associate.maintenancerecord.model.MaintenanceRecord;
import com.steerinfo.associate.maintenancerecord.service.IMaintenanceRecordService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MaintenanceRecord RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-02-16 02:57
 * 类描述
 * 修订历史：
 * 日期：2022-02-16
 * 作者：generator
 * 参考：
 * 描述：MaintenanceRecord RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/maintenancerecords")
@Api(value = "/${api.version}/maintenancerecords", tags = "故障维修记录 - MaintenanceRecordController")
public class MaintenanceRecordController extends BaseRESTfulController {

    @Autowired
    IMaintenanceRecordService maintenanceRecordService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("maintenancerecord:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MaintenanceRecord> list = maintenanceRecordService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("maintenancerecord:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MaintenanceRecord> list = maintenanceRecordService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("maintenancerecord:view")
    @PostMapping(value = "/like/")
    public RESTfulResult listpost(@RequestBody HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MaintenanceRecord> list = maintenanceRecordService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MaintenanceRecord对象创建")
    @ApiImplicitParam(name = "maintenanceRecord", value = "详细实体maintenanceRecord", required = true, dataType = "MaintenanceRecord")
    //@RequiresPermissions("maintenancerecord:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MaintenanceRecord model){
        try{
            String msg = maintenanceRecordService.checkandadd(model);
            if (msg != "" && !msg.equals("")){
                return failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常,请确认");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("maintenancerecord:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MaintenanceRecord maintenanceRecord = maintenanceRecordService.getById(id);
        return success(maintenanceRecord);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的maintenanceRecord信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "maintenanceRecord", value = "详细实体maintenanceRecord", required = true, dataType = "MaintenanceRecord")
    })
    //@RequiresPermissions("maintenancerecord:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MaintenanceRecord model){
        try{
            String msg = maintenanceRecordService.checkandupdate(id,model);
            if (msg != "" && !msg.equals("")){
                return failed(null,msg);
            }
        }catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常,请确认");
        }
        return success();
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("maintenancerecord:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  maintenanceRecordService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("maintenancerecord:delete")
    @PutMapping(value = "/deleteBacth")//String
    public RESTfulResult deleteBacth(@RequestBody List<MaintenanceRecord> model){
        List<String> list = new ArrayList<>();
        for(MaintenanceRecord models: model){
            list.add(models.getMaintenanceRecordNo());
        }
        if(ListUtils.isNotEmpty(list)) {
            List<String> ids = ListUtils.convertList(list);
            maintenanceRecordService.delete(ids);
        }
        return success();
    }
}
